diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_motd.c ircd-hybrid-7-bg/modules/m_motd.c
--- ircd-hybrid-7rc5/modules/m_motd.c	Mon Oct  7 20:23:46 2002
+++ ircd-hybrid-7-bg/modules/m_motd.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_motd.c,v 1.31 2002/10/08 00:23:46 db Exp $
+ *  $Id: m_motd.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -36,6 +36,7 @@
 #include "parse.h"
 #include "modules.h"
 #include "s_conf.h"
+#include "s_misc.h"
 
 
 static void mr_motd(struct Client *, struct Client *, int, char **);
@@ -63,7 +64,7 @@
   mod_del_cmd(&motd_msgtab);
 }
 
-const char *_version = "$Revision: 1.31 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /* mr_motd()
@@ -91,7 +92,7 @@
   if((last_used + ConfigFileEntry.pace_wait) > CurrentTime)
     {
       /* safe enough to give this on a local connect only */
-      sendto_one(source_p,form_str(RPL_LOAD2HI),me.name,source_p->name);
+      sendto_one(source_p,form_str(source_p,RPL_LOAD2HI),me.name,source_p->name);
       return;
     }
   else
@@ -117,6 +118,8 @@
 static void mo_motd(struct Client *client_p, struct Client *source_p,
                    int parc, char *parv[])
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if(!IsClient(source_p))
     return;
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_names.c ircd-hybrid-7-bg/modules/m_names.c
--- ircd-hybrid-7rc5/modules/m_names.c	Thu Aug 15 11:00:59 2002
+++ ircd-hybrid-7-bg/modules/m_names.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_names.c,v 1.44 2002/08/15 15:00:59 adx Exp $
+ *  $Id: m_names.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -67,7 +67,7 @@
   mod_del_cmd(&names_msgtab);
 }
 
-const char *_version = "$Revision: 1.44 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 
 /************************************************************************
@@ -109,7 +109,7 @@
 
       if (!check_channel_name(para))
         { 
-          sendto_one(source_p, form_str(ERR_BADCHANNAME),
+          sendto_one(source_p, form_str(source_p,ERR_BADCHANNAME),
                      me.name, parv[0], (unsigned char *)para);
           return;
         }
@@ -141,14 +141,14 @@
             }
         }
       else
-        sendto_one(source_p, form_str(RPL_ENDOFNAMES), me.name,
+        sendto_one(source_p, form_str(source_p,RPL_ENDOFNAMES), me.name,
                    parv[0], para);
     }
   else
     {
       names_all_visible_channels(source_p);
       names_non_public_non_secret(source_p);
-      sendto_one(source_p, form_str(RPL_ENDOFNAMES), me.name, parv[0],
+      sendto_one(source_p, form_str(source_p,RPL_ENDOFNAMES), me.name, parv[0],
                  "*");
     }
 }
@@ -213,7 +213,7 @@
   char buf[BUFSIZE];
   char *t;
 
-  ircsprintf(buf,form_str(RPL_NAMREPLY),
+  ircsprintf(buf,form_str(source_p,RPL_NAMREPLY),
              me.name,source_p->name," * * :");
 
   mlen = strlen(buf);
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_nburst.c ircd-hybrid-7-bg/modules/m_nburst.c
--- ircd-hybrid-7rc5/modules/m_nburst.c	Fri May 24 19:34:21 2002
+++ ircd-hybrid-7-bg/modules/m_nburst.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_nburst.c,v 1.17 2002/05/24 23:34:21 androsyn Exp $
+ *  $Id: m_nburst.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
@@ -62,7 +62,7 @@
   mod_del_cmd(&nburst_msgtab);
 }
 
-const char *_version = "$Revision: 1.17 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 /*
 ** m_nburst
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_oper.c ircd-hybrid-7-bg/modules/m_oper.c
--- ircd-hybrid-7rc5/modules/m_oper.c	Tue Sep 10 15:58:32 2002
+++ ircd-hybrid-7-bg/modules/m_oper.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_oper.c,v 1.56 2002/09/10 19:58:32 db Exp $
+ *  $Id: m_oper.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -74,7 +74,7 @@
   mod_del_cmd(&oper_msgtab);
 }
 
-const char *_version = "$Revision: 1.56 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 
 /*
@@ -98,7 +98,7 @@
 
   if (EmptyString(password))
   {
-    sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+    sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
 	       me.name, source_p->name, "OPER");
     return;
   }
@@ -109,7 +109,7 @@
 
   if((aconf = find_password_aconf(name,source_p)) == NULL)
   {
-    sendto_one(source_p, form_str(ERR_NOOPERHOST), me.name, source_p->name);
+    sendto_one(source_p, form_str(source_p,ERR_NOOPERHOST), me.name, source_p->name);
     if (ConfigFileEntry.failed_oper_notice)
     {
       sendto_realops_flags(FLAGS_ALL, L_ALL,
@@ -160,7 +160,7 @@
   }
   else
   {
-    sendto_one(source_p,form_str(ERR_PASSWDMISMATCH),me.name, parv[0]);
+    sendto_one(source_p,form_str(source_p,ERR_PASSWDMISMATCH),me.name, parv[0]);
     if (ConfigFileEntry.failed_oper_notice)
     {
       sendto_realops_flags(FLAGS_ALL, L_ALL,
@@ -182,7 +182,7 @@
 mo_oper(struct Client *client_p, struct Client *source_p,
 	int parc, char *parv[])
 {
-  sendto_one(source_p, form_str(RPL_YOUREOPER), me.name, parv[0]);
+  sendto_one(source_p, form_str(source_p,RPL_YOUREOPER), me.name, parv[0]);
   SendMessageFile(source_p, &ConfigFileEntry.opermotd);
   return;
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_operwall.c ircd-hybrid-7-bg/modules/m_operwall.c
--- ircd-hybrid-7rc5/modules/m_operwall.c	Fri May 24 19:34:21 2002
+++ ircd-hybrid-7-bg/modules/m_operwall.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_operwall.c,v 1.29 2002/05/24 23:34:21 androsyn Exp $
+ *  $Id: m_operwall.c,v 1.4 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -33,6 +33,7 @@
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
+#include "s_misc.h"
 
 static void mo_operwall(struct Client*, struct Client*, int, char**);
 static void ms_operwall(struct Client*, struct Client*, int, char**);
@@ -55,7 +56,7 @@
   mod_del_cmd(&operwall_msgtab);
 }
 
-const char *_version = "$Revision: 1.29 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 /*
  * mo_operwall - OPERWALL message handler
@@ -71,14 +72,14 @@
 
   if (EmptyString(message))
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "OPERWALL");
       return;
     }
 
   sendto_server(NULL, source_p, NULL, NOCAPS, NOCAPS, LL_ICLIENT,
                 ":%s OPERWALL :%s", parv[0], message);
-  sendto_wallops_flags(FLAGS_OPERWALL, source_p, "OPERWALL - %s", message);
+  sendto_wallops_flags(FLAGS_OPERWALL, source_p, "[O] %s", message);
 }
 
 /*
@@ -92,18 +93,21 @@
                        int parc, char *parv[])
 {
   char *message = parv[1];
+  
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  message = parv[1];
 
   if (EmptyString(message))
     {
       if (MyClient(source_p))
-        sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+        sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                    me.name, parv[0], "OPERWALL");
       return;
     }
 
   sendto_server(client_p, source_p, NULL, NOCAPS, NOCAPS, LL_ICLIENT,
                 ":%s OPERWALL :%s", parv[0], message);
-  sendto_wallops_flags(FLAGS_OPERWALL, source_p, "OPERWALL - %s", message);
+  sendto_wallops_flags(FLAGS_OPERWALL, source_p, "[O] %s", message);
 }
 
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_pass.c ircd-hybrid-7-bg/modules/m_pass.c
--- ircd-hybrid-7rc5/modules/m_pass.c	Fri May 24 19:34:21 2002
+++ ircd-hybrid-7-bg/modules/m_pass.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_pass.c,v 1.23 2002/05/24 23:34:21 androsyn Exp $
+ *  $Id: m_pass.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -53,7 +53,7 @@
   mod_del_cmd(&pass_msgtab);
 }
 
-const char *_version = "$Revision: 1.23 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * m_pass() - Added Sat, 4 March 1989
@@ -71,7 +71,7 @@
 
   if (EmptyString(password))
     {
-      sendto_one(client_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(client_p, form_str(client_p,ERR_NEEDMOREPARAMS),
                  me.name, BadPtr(parv[0]) ? "*" : parv[0], "PASS");
       return;
     }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_ping.c ircd-hybrid-7-bg/modules/m_ping.c
--- ircd-hybrid-7rc5/modules/m_ping.c	Fri Oct 11 23:38:13 2002
+++ ircd-hybrid-7-bg/modules/m_ping.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_ping.c,v 1.32 2002/10/12 03:38:13 db Exp $
+ *  $Id: m_ping.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -35,6 +35,7 @@
 #include "hash.h"
 #include "s_conf.h"
 #include "s_serv.h"
+#include "s_misc.h"
 
 static void m_ping(struct Client*, struct Client*, int, char**);
 static void ms_ping(struct Client*, struct Client*, int, char**);
@@ -57,7 +58,7 @@
   mod_del_cmd(&ping_msgtab);
 }
 
-const char *_version = "$Revision: 1.32 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
 ** m_ping
@@ -75,7 +76,7 @@
 
   if (parc < 2 || *parv[1] == '\0')
   {
-    sendto_one(source_p, form_str(ERR_NOORIGIN), me.name, parv[0]);
+    sendto_one(source_p, form_str(source_p,ERR_NOORIGIN), me.name, parv[0]);
     return;
   }
 
@@ -111,7 +112,7 @@
     }
     else
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHSERVER),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHSERVER),
                  me.name, parv[0], destination);
       return;
     }
@@ -128,10 +129,16 @@
 {
   struct Client *target_p;
   char  *origin, *destination;
+  
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  if (parc > 0 && parv[1] && !strchr(parv[1], '.'))
+  	cluster_prefix(client_p, parc, parv, 1, 0, 0);
+  if (parc > 1 && parv[2] && !strchr(parv[2], '.'))
+  	cluster_prefix(client_p, parc, parv, 2, 0, 0);
 
   if (parc < 2 || *parv[1] == '\0')
   {
-    sendto_one(source_p, form_str(ERR_NOORIGIN), me.name, parv[0]);
+    sendto_one(source_p, form_str(source_p,ERR_NOORIGIN), me.name, parv[0]);
     return;
   }
 
@@ -157,7 +164,7 @@
                  origin, destination);
     else
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHSERVER),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHSERVER),
                  me.name, parv[0], destination);
       return;
     }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_pong.c ircd-hybrid-7-bg/modules/m_pong.c
--- ircd-hybrid-7rc5/modules/m_pong.c	Thu Aug 15 10:15:32 2002
+++ ircd-hybrid-7-bg/modules/m_pong.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_pong.c,v 1.28 2002/08/15 14:15:32 db Exp $
+ *  $Id: m_pong.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -38,6 +38,7 @@
 #include "parse.h"
 #include "hash.h"
 #include "modules.h"
+#include "s_misc.h"
 
 static void mr_pong(struct Client*, struct Client*, int, char**);
 static void ms_pong(struct Client*, struct Client*, int, char**);
@@ -60,7 +61,7 @@
   mod_del_cmd(&pong_msgtab);
 }
 
-const char *_version = "$Revision: 1.28 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 static void ms_pong(struct Client *client_p,
                    struct Client *source_p,
@@ -70,9 +71,15 @@
   struct Client *target_p;
   char  *origin, *destination;
 
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  if (parc > 0 && parv[1] && !strchr(parv[1], '.'))
+  	cluster_prefix(client_p, parc, parv, 1, 0, 0);
+  if (parc > 1 && parv[2] && !strchr(parv[2], '.'))
+  	cluster_prefix(client_p, parc, parv, 2, 0, 0);
+
   if (parc < 2 || *parv[1] == '\0')
     {
-      sendto_one(source_p, form_str(ERR_NOORIGIN), me.name, parv[0]);
+      sendto_one(source_p, form_str(source_p,ERR_NOORIGIN), me.name, parv[0]);
       return;
     }
 
@@ -94,7 +101,7 @@
                    parv[0], origin, destination);
       else
         {
-          sendto_one(source_p, form_str(ERR_NOSUCHSERVER),
+          sendto_one(source_p, form_str(source_p,ERR_NOSUCHSERVER),
                      me.name, parv[0], destination);
           return;
         }
@@ -128,7 +135,7 @@
 	  }
 	  else
 	  {
-		sendto_one(source_p, form_str(ERR_WRONGPONG), me.name,
+		sendto_one(source_p, form_str(source_p,ERR_WRONGPONG), me.name,
 			   source_p->name, source_p->localClient->random_ping);
 		return;
 	  }
@@ -137,7 +144,7 @@
      
     }
   else
-    sendto_one(source_p, form_str(ERR_NOORIGIN), me.name, parv[0]);
+    sendto_one(source_p, form_str(source_p,ERR_NOORIGIN), me.name, parv[0]);
   
   source_p->flags &= ~FLAGS_PINGSENT;
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_post.c ircd-hybrid-7-bg/modules/m_post.c
--- ircd-hybrid-7rc5/modules/m_post.c	Fri May 24 19:34:22 2002
+++ ircd-hybrid-7-bg/modules/m_post.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_post.c,v 1.11 2002/05/24 23:34:22 androsyn Exp $
+ *  $Id: m_post.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
@@ -65,7 +65,7 @@
   mod_del_cmd(&post_msgtab);
 }
 
-const char *_version = "$Revision: 1.11 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 /*
 ** mr_dumb_proxy
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_rehash.c ircd-hybrid-7-bg/modules/m_rehash.c
--- ircd-hybrid-7rc5/modules/m_rehash.c	Wed Oct 16 22:28:51 2002
+++ ircd-hybrid-7-bg/modules/m_rehash.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_rehash.c,v 1.42 2002/10/17 02:28:51 bill Exp $
+ *  $Id: m_rehash.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -60,7 +60,7 @@
   mod_del_cmd(&rehash_msgtab);
 }
 
-const char *_version = "$Revision: 1.42 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * mo_rehash - REHASH message handler
@@ -81,7 +81,7 @@
     {
       if(irccmp(parv[1],"DNS") == 0)
         {
-          sendto_one(source_p, form_str(RPL_REHASHING), me.name, parv[0], "DNS");
+          sendto_one(source_p, form_str(source_p,RPL_REHASHING), me.name, parv[0], "DNS");
           sendto_realops_flags(FLAGS_ALL, L_ALL,"%s is rehashing DNS",
                                get_oper_name(source_p));
           restart_resolver();   /* re-read /etc/resolv.conf AGAIN?
@@ -118,7 +118,7 @@
     }
   else
     {
-      sendto_one(source_p, form_str(RPL_REHASHING), me.name, parv[0],
+      sendto_one(source_p, form_str(source_p,RPL_REHASHING), me.name, parv[0],
                  ConfigFileEntry.configfile);
       sendto_realops_flags(FLAGS_ALL, L_ALL,
 			   "%s is rehashing server config file",
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_restart.c ircd-hybrid-7-bg/modules/m_restart.c
--- ircd-hybrid-7rc5/modules/m_restart.c	Fri May 24 19:34:22 2002
+++ ircd-hybrid-7-bg/modules/m_restart.c	Mon Mar 10 01:09:01 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_restart.c,v 1.23 2002/05/24 23:34:22 androsyn Exp $
+ *  $Id: m_restart.c,v 1.2 2003/03/10 06:09:01 demond Exp $
  */
 
 #include "stdinc.h"
@@ -57,7 +57,7 @@
   mod_del_cmd(&restart_msgtab);
 }
 
-const char *_version = "$Revision: 1.23 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * mo_restart
@@ -74,7 +74,7 @@
   
   if (!MyClient(source_p) || !IsOper(source_p))
     {
-      sendto_one(source_p, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES), me.name, parv[0]);
       return;
     }
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_resv.c ircd-hybrid-7-bg/modules/m_resv.c
--- ircd-hybrid-7rc5/modules/m_resv.c	Fri May 24 19:34:22 2002
+++ ircd-hybrid-7-bg/modules/m_resv.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_resv.c,v 1.16 2002/05/24 23:34:22 androsyn Exp $
+ *  $Id: m_resv.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
@@ -65,7 +65,7 @@
   mod_del_cmd(&unresv_msgtab);
 }
 
-const char *_version = "$Revision: 1.16 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 
 /*
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_set.c ircd-hybrid-7-bg/modules/m_set.c
--- ircd-hybrid-7rc5/modules/m_set.c	Fri May 24 19:34:22 2002
+++ ircd-hybrid-7-bg/modules/m_set.c	Tue Jan  7 21:50:23 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_set.c,v 1.45 2002/05/24 23:34:22 androsyn Exp $
+ *  $Id: m_set.c,v 1.3 2003/01/08 02:50:23 demond Exp $
  */
 
 /* rewritten by jdc */
@@ -64,7 +64,7 @@
   mod_del_cmd(&set_msgtab);
 }
 
-const char *_version = "$Revision: 1.45 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /* Structure used for the SET table itself */
 struct SetStruct
@@ -328,9 +328,16 @@
 #ifdef USE_GETTEXT
   if(locale)
   {
-    char langenv[BUFSIZE];
+    static char langenv[BUFSIZE];
+    static char langenv2[BUFSIZE];
     ircsprintf(langenv,"LANGUAGE=%s",locale);
     putenv(langenv);
+    ircsprintf(langenv2,"LC_MESSAGES=%s",locale);
+    putenv(langenv2);
+	{
+	  extern int  _nl_msg_cat_cntr;
+	  ++_nl_msg_cat_cntr;
+	}
 
     sendto_one(source_p, ":%s NOTICE %s :Set MSGLOCALE to '%s'",
 	me.name, source_p->name,
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_stats.c ircd-hybrid-7-bg/modules/m_stats.c
--- ircd-hybrid-7rc5/modules/m_stats.c	Wed Sep  4 21:10:24 2002
+++ ircd-hybrid-7-bg/modules/m_stats.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_stats.c,v 1.112 2002/09/05 01:10:24 db Exp $
+ *  $Id: m_stats.c,v 1.3 2003/05/24 00:07:45 demond Exp $
  */
 
 #include "stdinc.h"
@@ -80,7 +80,7 @@
   mod_del_cmd(&stats_msgtab);
 }
 
-const char *_version = "$Revision: 1.112 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 const char* Lformat = ":%s %d %s %s %u %u %u %u %u :%u %u %s";
@@ -125,11 +125,16 @@
 static void stats_shared(struct Client *);
 static void stats_servers(struct Client *);
 static void stats_gecos(struct Client *);
+static void stats_userparms(struct Client *);
 static void stats_class(struct Client *);
 static void stats_memory(struct Client *);
+static void stats_services(struct Client *);
+static void stats_equivs(struct Client *);
+static void stats_relays(struct Client *);
 static void stats_servlinks(struct Client *);
 static void stats_ltrace(struct Client *, int, char**);
 static void stats_ziplinks(struct Client *);
+static void stats_clusters(struct Client *);
 
 /* This table contains the possible stats items, in order:
  * /stats name,  function to call, operonly? adminonly? /stats letter
@@ -139,34 +144,38 @@
   /* letter     function            need_oper need_admin */
   { 'a',	stats_adns_servers,	1,	1,	},
   { 'A',	stats_adns_servers,	1,	1,	},
+  { 'b',	stats_clusters,		1,	1,	},
+  { 'B',	stats_clusters,		1,	1,	},
   { 'c',	stats_connect,		1,	0,	},
   { 'C',	stats_connect,		1,	0,	},
-  { 'd',	stats_deny,		1,	0,	},
-  { 'D',	stats_deny,		1,	0,	},
+  { 'd',	stats_deny,			1,	0,	},
+  { 'D',	stats_deny,			1,	0,	},
   { 'e', 	stats_exempt,		1,	0,	},
   { 'E',	stats_events,		1,	1,	},
-  { 'f',	fd_dump,		1,	1,	},
-  { 'F',	fd_dump,		1,	1,	},
+  { 'f',	fd_dump,			1,	1,	},
+  { 'F',	fd_dump,			1,	1,	},
   { 'g',	stats_pending_glines,	1,	0,	},
   { 'G',	stats_glines,		1,	0,	},
   { 'h',	stats_hubleaf,		1,	0,	},
   { 'H',	stats_hubleaf,		1,	0,	},
-  { 'i',	stats_auth,		0,	0,	},
-  { 'I',	stats_auth,		0,	0,	},
+  { 'i',	stats_auth,			0,	0,	},
+  { 'I',	stats_auth,			0,	0,	},
   { 'k',	stats_tklines,		0,	0,	},
   { 'K',	stats_klines,		0,	0,	},
   { 'l',	stats_ltrace,		1,	0,	},
   { 'L',	stats_ltrace,		1,	0,	},
   { 'm',	stats_messages,		0,	0,	},
   { 'M',	stats_messages,		0,	0,	},
-  { 'o',	stats_oper,		0,	0,	},
-  { 'O',	stats_oper,		0,	0,	},
+  { 'o',	stats_oper,			0,	0,	},
+  { 'O',	stats_oper,			0,	0,	},
   { 'p',	stats_operedup,		0,	0,	},
   { 'P',	stats_ports,		0,	0,	},
-  { 'q',	stats_resv,		1,	0,	},
-  { 'Q',	stats_resv,		1,	0,	},
+  { 'q',	stats_resv,			1,	0,	},
+  { 'Q',	stats_resv,			1,	0,	},
   { 'r',	stats_usage,		1,	0,	},
-  { 'R',	stats_usage,		1,	0,	},
+  { 'R',	stats_relays,		1,	0,	},
+  { 's',	stats_services,		1,	0,	},
+  { 'S',	stats_services,		1,	0,	},
   { 't',	stats_tstats,		1,	0,	},
   { 'T',	stats_tstats,		1,	0,	},
   { 'u',	stats_uptime,		0,	0,	},
@@ -174,9 +183,9 @@
   { 'v',	stats_servers,		1,	0,	},
   { 'V',	stats_servers,		1,	0,	},
   { 'x',	stats_gecos,		1,	0,	},
-  { 'X',	stats_gecos,		1,	0,	},
+  { 'X',	stats_userparms,	1,	0,	},
   { 'y',	stats_class,		1,	0,	},
-  { 'Y',	stats_class,		1,	0,	},
+  { 'Y',	stats_equivs,		1,	0,	},
   { 'z',	stats_memory,		1,	0,	},
   { 'Z',	stats_ziplinks,		1,	0,	},
   { '?',	stats_servlinks,	0,	0,	},
@@ -205,7 +214,7 @@
     {
       /* safe enough to give this on a local connect only */
       if(MyClient(source_p))
-	sendto_one(source_p,form_str(RPL_LOAD2HI),me.name,parv[0]);
+	sendto_one(source_p,form_str(source_p,RPL_LOAD2HI),me.name,parv[0]);
       return;
     }
   else
@@ -229,7 +238,7 @@
       /* The stats table says what privs are needed, so check --fl_ */
       if(stats_cmd_table[i].need_oper || stats_cmd_table[i].need_admin)
       {
-        sendto_one(source_p, form_str(ERR_NOPRIVILEGES),me.name,source_p->name);
+        sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES),me.name,source_p->name);
         break;
       }
 
@@ -242,7 +251,7 @@
   }
 
   /* Send the end of stats notice, and the stats_spy */
-  sendto_one(source_p, form_str(RPL_ENDOFSTATS), me.name, parv[0], parv[1]);
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFSTATS), me.name, parv[0], parv[1]);
 
   if((statchar != 'L') && (statchar != 'l'))
     stats_spy(source_p, statchar);
@@ -280,7 +289,7 @@
       if((stats_cmd_table[i].need_admin && !IsOperAdmin(source_p)) ||
          (stats_cmd_table[i].need_oper && !IsOper(source_p)))
       {
-        sendto_one(source_p, form_str(ERR_NOPRIVILEGES),me.name,source_p->name);
+        sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES),me.name,source_p->name);
         break;
       }
 
@@ -293,7 +302,7 @@
   }
 
   /* Send the end of stats notice, and the stats_spy */
-  sendto_one(source_p, form_str(RPL_ENDOFSTATS), me.name, parv[0], parv[1]);
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFSTATS), me.name, parv[0], parv[1]);
 
   if((statchar != 'L') && (statchar != 'l'))
     stats_spy(source_p, statchar);
@@ -333,7 +342,7 @@
 	get_printable_conf(aconf, &name, &host, &pass, &user, &port,
 	                  &classname);
 			  
-	sendto_one(source_p, form_str(RPL_STATSDLINE), me.name,
+	sendto_one(source_p, form_str(source_p,RPL_STATSDLINE), me.name,
 	           source_p->name, 'D', host, pass);
       }
     }
@@ -364,7 +373,7 @@
 	get_printable_conf(aconf, &name, &host, &pass,
 	                   &user, &port, &classname);
 	
-	sendto_one(source_p, form_str(RPL_STATSDLINE), me.name,
+	sendto_one(source_p, form_str(source_p,RPL_STATSDLINE), me.name,
 	           source_p->name, 'e', host, pass);
       }
     }
@@ -481,7 +490,7 @@
     else
       reason = "No Reason";
     
-    sendto_one(source_p, form_str(RPL_STATSKLINE), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_STATSKLINE), me.name,
 	       source_p->name, 'G', host, name, reason);
   }
 }
@@ -499,7 +508,7 @@
 {
   /* Oper only, if unopered, return ERR_NOPRIVS */
   if((ConfigFileEntry.stats_i_oper_only == 2) && !IsOper(source_p))
-    sendto_one(source_p, form_str(ERR_NOPRIVILEGES),
+    sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES),
                me.name, source_p->name);
 
   /* If unopered, Only return matching auth blocks */
@@ -511,13 +520,13 @@
 
     if(MyConnect(source_p))
       aconf = find_conf_by_address(source_p->host,
-                                   &source_p->localClient->ip,
+                   &source_p->localClient->ip,
 				   CONF_CLIENT,
 				   source_p->localClient->aftype,
-				   source_p->username);
+				   source_p->username, NULL);
     else
       aconf = find_conf_by_address(source_p->host, NULL, CONF_CLIENT,
-                                   0, source_p->username);
+                                   0, source_p->username, NULL);
 
     if(aconf == NULL)
       return;
@@ -525,7 +534,7 @@
     get_printable_conf(aconf, &name, &host, &pass, &user, 
                        &port, &classname);
 
-    sendto_one(source_p, form_str(RPL_STATSILINE), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_STATSILINE), me.name,
                source_p->name, (IsConfRestricted(aconf)) ? 'i' : 'I',
 	       name, show_iline_prefix(source_p, aconf, user), host,
 	       port, classname);
@@ -542,7 +551,7 @@
 {
   /* Oper only, if unopered, return ERR_NOPRIVS */
   if((ConfigFileEntry.stats_k_oper_only == 2) && !IsOper(source_p))
-    sendto_one(source_p, form_str(ERR_NOPRIVILEGES),
+    sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES),
                me.name, source_p->name);
 
   /* If unopered, Only return matching klines */
@@ -554,13 +563,13 @@
 
     if(MyConnect(source_p))
       aconf = find_conf_by_address(source_p->host,
-                                   &source_p->localClient->ip,
+                   &source_p->localClient->ip,
 				   CONF_KILL,
 				   source_p->localClient->aftype,
-				   source_p->username);
+				   source_p->username, NULL);
     else
       aconf = find_conf_by_address(source_p->host, NULL, CONF_KILL,
-                                   0, source_p->username);
+                                   0, source_p->username, NULL);
 
     if(aconf == NULL)
       return;
@@ -572,7 +581,7 @@
     get_printable_conf(aconf, &name, &host, &pass, &user,
                        &port, &classname);
 
-    sendto_one(source_p, form_str(RPL_STATSKLINE), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_STATSKLINE), me.name,
                source_p->name, 'k', host, user, pass);
   }
   /* Theyre opered, or allowed to see all klines */
@@ -586,7 +595,7 @@
 {
   /* Oper only, if unopered, return ERR_NOPRIVS */
   if((ConfigFileEntry.stats_k_oper_only == 2) && !IsOper(source_p))
-    sendto_one(source_p, form_str(ERR_NOPRIVILEGES),
+    sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES),
                me.name, source_p->name);
 
   /* If unopered, Only return matching klines */
@@ -599,13 +608,13 @@
     /* search for a kline */
     if(MyConnect(source_p))
       aconf = find_conf_by_address(source_p->host,
-                                   &source_p->localClient->ip,
+                   &source_p->localClient->ip,
 				   CONF_KILL,
 				   source_p->localClient->aftype,
-				   source_p->username);
+				   source_p->username, NULL);
     else
       aconf = find_conf_by_address(source_p->host, NULL, CONF_KILL,
-                                   0, source_p->username);
+                                   0, source_p->username, NULL);
 
     if(aconf == NULL)
       return;
@@ -617,7 +626,7 @@
     get_printable_conf(aconf, &name, &host, &pass, &user,
                        &port, &classname);
 
-    sendto_one(source_p, form_str(RPL_STATSKLINE), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_STATSKLINE), me.name,
                source_p->name, 'K', host, user, pass);
   }
   /* Theyre opered, or allowed to see all klines */
@@ -635,7 +644,7 @@
 stats_oper(struct Client *source_p)
 {
   if (!IsOper(source_p) && ConfigFileEntry.stats_o_oper_only)
-    sendto_one(source_p, form_str(ERR_NOPRIVILEGES),me.name,source_p->name);
+    sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES),me.name,source_p->name);
   else
     report_configured_links(source_p, CONF_OPERATOR);
 }
@@ -694,7 +703,7 @@
 stats_ports(struct Client *source_p)
 {
   if (!IsOper(source_p) && ConfigFileEntry.stats_P_oper_only)
-    sendto_one(source_p, form_str(ERR_NOPRIVILEGES),me.name,source_p->name);
+    sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES),me.name,source_p->name);
   else
     show_ports(source_p);
 }
@@ -705,6 +714,31 @@
   report_resv(source_p);
 }
 
+static void stats_services(struct Client *client_p)
+{
+  report_zlines(client_p);
+}
+
+static void stats_equivs(struct Client *client_p)
+{
+  report_equivs(client_p);
+}
+
+static void stats_relays(struct Client *client_p)
+{
+  report_relays(client_p);
+}
+
+static void stats_userparms(struct Client *client_p)
+{
+  report_userparms(client_p);
+}
+
+static void stats_clusters(struct Client *client_p)
+{
+  report_clusters(client_p);
+}
+
 static void
 stats_usage(struct Client *source_p)
 {
@@ -723,10 +757,10 @@
   time_t now;
 
    now = CurrentTime - me.since;
-   sendto_one(source_p, form_str(RPL_STATSUPTIME), me.name, source_p->name,
+   sendto_one(source_p, form_str(source_p,RPL_STATSUPTIME), me.name, source_p->name,
               now/86400, (now/3600)%24, (now/60)%60, now%60);
    if(!ConfigServerHide.disable_remote || IsOper(source_p))
-      sendto_one(source_p, form_str(RPL_STATSCONN), me.name, source_p->name,
+      sendto_one(source_p, form_str(source_p,RPL_STATSCONN), me.name, source_p->name,
                  MaxConnectionCount, MaxClientCount, Count.totalrestartcount);
 }
 
@@ -825,7 +859,7 @@
 
   if(ConfigServerHide.flatten_links && !IsOper(source_p))
   {
-    sendto_one(source_p, form_str(ERR_NOPRIVILEGES),me.name, source_p->name);
+    sendto_one(source_p, form_str(source_p,ERR_NOPRIVILEGES),me.name, source_p->name);
     return;
   }
 
@@ -892,7 +926,7 @@
     stats_L_spy(source_p, statchar, name);
   }
   else
-    sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+    sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                me.name, source_p->name, "STATS");
 
   return;
@@ -909,6 +943,8 @@
 ms_stats(struct Client *client_p, struct Client *source_p,
                     int parc, char *parv[])
 {
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+
   if (hunt_server(client_p,source_p,":%s STATS %s :%s",2,parc,parv)!=HUNTED_ISME)
     return;
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_svinfo.c ircd-hybrid-7-bg/modules/m_svinfo.c
--- ircd-hybrid-7rc5/modules/m_svinfo.c	Fri May 24 19:34:22 2002
+++ ircd-hybrid-7-bg/modules/m_svinfo.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_svinfo.c,v 1.34 2002/05/24 23:34:22 androsyn Exp $
+ *  $Id: m_svinfo.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 #include "stdinc.h"
 #include "handlers.h"
@@ -56,7 +56,7 @@
   mod_del_cmd(&svinfo_msgtab);
 }
 
-const char *_version = "$Revision: 1.34 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 /*
  * ms_svinfo - SVINFO message handler
